//+------------------------------------------------------------------+
//|                                                 a_MACD_Alert.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window

#property  indicator_buffers 3

#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Gray


//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];

extern int Fast = 12;
extern int Slow = 26;
extern int Signal = 9;

bool flag = true;
datetime TimeOld;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);

   TimeOld = Time[0];

//----  
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{

//----   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{

   int limit = Bars-IndicatorCounted();

//---- 

   for(int i=limit-1; i>=0; i--){
      Buffer1[i]=iMACD(NULL,0,Fast,Slow,Signal,PRICE_CLOSE,MODE_MAIN,i); 
      Buffer2[i]=iMACD(NULL,0,Fast,Slow,Signal,PRICE_CLOSE,MODE_SIGNAL,i);     
      Buffer3[i]=Buffer1[i] - Buffer2[i];
   }


   if (Time[0] != TimeOld)
   {
      flag = true;
      TimeOld = Time[0];
   }

   if (flag)
   {

      if ((Buffer1[0] > Buffer2[0]) && (Buffer1[1] < Buffer2[1]))
      {
         Alert("MACD LongSign");
         flag = false;
      }
      
      if ((Buffer1[0] < Buffer2[0]) && (Buffer1[1] > Buffer2[1]))
      {
         Alert("MACD ShortSign");
         flag = false;
      }

   } 



//----     
   return(0);
}

//+------------------------------------------------------------------+